/*
 * AdjacencyListUnitTest.hpp
 *
 *  Created on: Oct 17, 2011
 *      Author: heber
 */

#ifndef UNITTEST_HPP_
#define UNITTEST_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <cppunit/extensions/HelperMacros.h>

#include "Graph/AdjacencyList.hpp"
#include "types.hpp"

// we prefer enum over define
enum { ATOM_COUNT = 10 };

class atom;
class molecule;
class World;

class AdjacencyListTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( AdjacencyListTest );
  CPPUNIT_TEST ( CreateMapTest );
  CPPUNIT_TEST ( ParseIntoMapTest );
  CPPUNIT_TEST ( StoreToFileTest );
  CPPUNIT_TEST ( operatorGreaterLessTest );
  CPPUNIT_TEST ( operatorEqualTest );
  CPPUNIT_TEST ( CheckAgainstSubsetTest );
  CPPUNIT_TEST_SUITE_END();

public:
  void setUp();
  void tearDown();

  void CreateMapTest();
  void ParseIntoMapTest();
  void StoreToFileTest();
  void operatorGreaterLessTest();
  void operatorEqualTest();
  void CheckAgainstSubsetTest();

private:
  AdjacencyList::AtomBondMap comparisonMap;
  std::vector<atom *> atoms;
  std::vector<atomId_t> atomIds;
  molecule * TestMolecule;
};

#endif /* UNITTEST_HPP_ */
